// -*- C++ -*-

/* window_test_plotcanvas.h
 * 
 * Copyright (C) 2000 GtkExtra-- Development Team  
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef HEADER_WINDOW_TEST_PLOTCANVAS
#define HEADER_WINDOW_TEST_PLOTCANVAS

#include "gtk--.h"
#include "gtk--/window.h"
#include <gtkextra--.h>

#include <iostream>
#include <string>
#include <string>
#include <vector>

using SigC::bind;
using SigC::slot;
//using namespace Gtk;
//using namespace GtkExtra;

class Window_Test_PlotCanvas : public Gtk::Window
{
public:
  Window_Test_PlotCanvas();
  virtual ~Window_Test_PlotCanvas();
  
protected:

  void build_example1(GtkExtra::Plot& refPlot);
  void build_example2(GtkExtra::Plot& refPlot);
  void activate_plot(gint iPlotNumber);
  
  //Signal handlers:
  virtual gint on_PlotCanvas_select_item(GdkEventButton* event, GtkPlotCanvasChild* item);
  virtual void on_Button_toggled(gint iButtonNumber);
  virtual gboolean on_axis_tick_label(gdouble *tick_value, gchar *label);
 
  
  //'virtual function' signal overrides:
  virtual gint delete_event_impl(GdkEventAny*);
  
protected:
 
  //Member widgets:

  Gtk::VBox m_VBox;
  Gtk::ScrolledWindow m_ScrolledWindow;
  GtkExtra::PlotCanvas m_PlotCanvas;
  GtkExtra::Plot m_Plot1, m_Plot2;
  Gtk::ToggleButton m_Button1, m_Button2;

  typedef std::vector<GtkExtra::PlotData*> type_vecpPlotData;
  type_vecpPlotData m_vecDataSets;
 
};

//Functions used by Plots:
//These can not be member methods.
gdouble function(GtkPlot *plot, GtkPlotData *data, gdouble x, gboolean *err);
gdouble gaussian(GtkPlot *plot, GtkPlotData *data, gdouble x, gboolean *err);


void draw_child(GtkPlotCanvas *canvas, GtkPlotCanvasChild *child);

#endif //HEADER_WINDOW_TEST_PLOTCANVAS
