// -*- C++ -*-

/* window_test_polar.h
 * 
 * Copyright (C) 2000 GtkExtra-- Development Team  
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef HEADER_WINDOW_TEST_POLAR
#define HEADER_WINDOW_TEST_POLAR

#include "gtk--.h"
#include "gtk--/window.h"
#include <gtkextra--.h>

#include <iostream>
#include <string>
#include <string>
#include <vector>

using SigC::bind;
using SigC::slot;
//using namespace Gtk;
//using namespace GtkExtra;

class Window_Test_Polar : public Gtk::Window
{
public:
  Window_Test_Polar();
  virtual ~Window_Test_Polar();
  
protected:

  void build_example1(GtkExtra::Plot& refPlot);
  void activate_plot();
  
  //Signal handlers:
  virtual void on_Button_toggled(gint iButtonNumber);
 
  
  //'virtual function' signal overrides:
  virtual gint delete_event_impl(GdkEventAny*);
  
protected:
 
  //Member widgets:

  Gtk::VBox m_VBox;
  Gtk::ScrolledWindow m_ScrolledWindow;
  GtkExtra::PlotCanvas m_PlotCanvas;
  GtkExtra::PlotPolar m_Plot1;
  Gtk::ToggleButton m_Button1; //Useless, but it's useless in the C example too.

  typedef std::vector<GtkExtra::PlotData*> type_vecpPlotData;
  type_vecpPlotData m_vecDataSets;
 
};

#endif //HEADER_WINDOW_TEST_POLAR
